<?php
class inet {
	
	public function __construct(){
		global $err;
		
		$act=preg_replace('/[^a-z_]/','',$_GET['act']);
		if($act){
			call_user_func(array(&$this,$act));
		} 
	}
	
	public function get(){
		global $DB;
		$limit=intval($_POST['limit']);
		$start=intval($_POST['start']);
		
		$dir=preg_replace("/[^(ASC|DESC)]/",'',$_POST['dir']);
		if($dir!='ASC'&&$dir!='DESC') $dir='ASC';
		$sort=$_POST['sort'];
		
		if(!$sort){
			$sort='id';
		}

		$where_str=array();
		
		function parse_sql_query($item){
			return $item;
		}
		
		$search=$_POST;
		if (strlen($search["username"]) && $search["username"] != "Логин"){
			$query = split(" ", $search["username"]);
			foreach ($query as $item)
			$where_str[] = " inter.username LIKE '%".parse_sql_query($item)."%'";
		}		
		if (strlen($search["ip_adress"]) && $search["ip_adress"]!="IP-адрес") $where_str[]= "inter.ip_adress LIKE '%".ip2long($search["ip_adress"])."%'";
		if (strlen($search["mac"]) && $search["mac"]!="МАС-адрес") $where_str[]= "inter.mac LIKE '%".$search["mac"]."%'";
		if (count($where_str)) {
			$where = join(" AND ", $where_str);			
		} else {
			$where = "1=1";
		}
		
		$data_t = $DB->selectPage($totalCount,"
								SELECT cli.balance,inter.*,pack.name AS pname,idate.name AS pay_day,vl.name AS vname
								FROM internet AS inter 
								LEFT JOIN packets AS pack ON (inter.packet_id=pack.id)
								LEFT JOIN idate ON (inter.time_id=idate.id)
								LEFT JOIN vlans AS vl ON (inter.vlan_id=vl.id)
								LEFT JOIN clients AS cli ON (inter.user_id=cli.id)
								WHERE $where 
								ORDER BY $sort $dir 
								LIMIT ?d,?d",$start,$limit);
		foreach($data_t as $data_k=>$data_v)
		{
			$data[$data_k]["id"] = $data_v["id"];
			$data[$data_k]["username"] = $data_v["username"];
			$data[$data_k]["pname"] = $data_v["pname"];
			$data[$data_k]["vname"] = $data_v["vname"];
			$data[$data_k]["pay_day"] = $data_v["pay_day"];
			$data[$data_k]["ip_adress"] = long2ip($data_v["ip_adress"]);
			$data[$data_k]["mac"] = $data_v["mac"];
			if($data_v["connected"]==1) $data[$data_k]["status"] = "Включена"; 
			else if($data_v["balance"]<0)$data[$data_k]["status"] = "Минусовой балланс"; 
			else $data[$data_k]["status"] = "Отключена";
		}
		$json=array("totalCount"=>$totalCount,"data"=>$data);
		echo json_encode($json);
	}
	
	public function save(){
		global $DB;

		$obj["user_id"]=intval($_GET[client_id]);
		$client_id=intval($_GET[client_id]);
		$have= $DB->selectCell("SELECT user_id FROM internet WHERE user_id=$client_id");
		if($obj["user_id"]==$have) error("Пользователь уже имеет услугу Интернета");
		$obj["username"]=$_GET[client_name];
		if($_POST['packet_id']!="Выберите пакет")$obj["packet_id"]=$_POST['packet_id'];
		if($_POST['time_id']!="Выберите расчётный период")$obj["time_id"]=$_POST['time_id'];
		if($_POST['vlan_id']!="Выберите Vlan")$obj["vlan_id"]=intval($_POST['vlan_id']);
		if(!$obj["time_id"]) error("Вы не выбрали расчётный период!");
		if(!$obj["packet_id"]) error("Вы не выбрали пакет!");
		if(!$obj["vlan_id"]) error("Вы не выбрали Vlan!");
		
		$DB->query("INSERT INTO internet set ?a",$obj);
 
		success();
	}
	
	public function update_packet(){
		global $DB;
		
		$id=intval($_GET[id]);
		if($_POST['packet_id']!="Выберите пакет")$obj["packet_id"]=$_POST['packet_id'];
		if(!$obj["packet_id"]) error("Вы не выбрали пакет!");
		$connected = $DB->selectCell("SELECT connected FROM internet WHERE id=$id");
		if($connected==1) error("Услуга в данный момент используется");
		$DB->query("UPDATE internet set ?a WHERE id=?d",$obj,$id);
 
		success();
	}

	public function update_idate(){
		global $DB;
		
		$id=intval($_GET[id]);
		if($_POST['time_id']!="Выберите расчётный период")$obj["time_id"]=$_POST['time_id'];
		if(!$obj["time_id"]) error("Вы не выбрали расчётный период!");
		$DB->query("UPDATE internet set ?a WHERE id=?d",$obj,$id);
 
		success();
	}
	
	public function update_vlan(){
		global $DB;
		
		$id=intval($_GET[id]);
		if($_POST['vlan_id']!="Выберите Vlan")$obj["vlan_id"]=intval($_POST['vlan_id']);
		if(!$obj["vlan_id"]) error("Вы не выбрали Vlan!");
		$obj["ip_adress"]=0;
		$connected = $DB->selectCell("SELECT connected FROM internet WHERE id=$id");
		if($connected==1) error("Услуга в данный момент используется");
		$DB->query("UPDATE internet set ?a WHERE id=?d",$obj,$id);
 
		success();
	}

	public function update_ip(){
		global $DB;
		
		$id=intval($_GET[id]);
		$obj["ip_adress"]=intval($_POST['ip_adress']); 
		if (!$obj["ip_adress"]) error("Вы не выбрали IP-адрес");
		$connected = $DB->selectCell("SELECT connected FROM internet WHERE id=$id");
		if($connected==1) error("Услуга в данный момент используется");
		$DB->query("UPDATE internet set ?a WHERE id=?d",$obj,$id);
 		success();
	}	
	
	public function update_mac(){
		global $DB;
		
		$id=intval($_GET[id]);
		$obj["mac"]="";
		$DB->query("UPDATE internet set ?a WHERE id=?d",$obj,$id);
		$ip=$DB->selectCell('SELECT ip_adress from internet WHERE id=?',$id);
		$ip_adress=long2ip($ip);
		$err=exec("/usr/local/bin/sudo /usr/sbin/arp -d $ip_adress",$output);
		success();
	}

	public function disable(){
		global $DB;
				
		$id=intval($_GET[id]);
		if($id)
		$ip=$DB->selectCell('SELECT ip_adress from internet WHERE id=?',$id);
		$packet=$DB->selectCell('SELECT packet_id from internet WHERE id=?',$id);
		$table=$packet+26;
		$ip_adress=long2ip($ip);
		$err=exec("/usr/local/bin/sudo /sbin/ipfw table $table delete $ip_adress",$output);
		$obj["connected"]=0;
		$DB->query("UPDATE internet set ?a WHERE id=?d",$obj,$id);
		success();
		
	}
	
	public function connect(){
		global $DB;
				
		$id=intval($_GET[id]);
		$client_id=intval($_GET[client_id]);
		if($id) $client_id=$DB->selectCell('SELECT user_id from internet WHERE id=?',$id);
		$connected=$DB->selectCell('SELECT connected from internet WHERE user_id=?',$client_id);
		if(!$connected)
		{
			$balance=$DB->selectCell("SELECT balance FROM clients WHERE id=$client_id");
			if($balance<0) error("У клиента минусовой балланс");
			$obj["connected"]=1;
			$ip=$DB->selectCell('SELECT ip_adress from internet WHERE user_id=?',$client_id);
			$packet=$DB->selectCell('SELECT packet_id from internet WHERE user_id=?',$client_id);
			$table=$packet+26;
			$ip_adress=long2ip($ip);
			$err=exec("/usr/local/bin/sudo /sbin/ipfw table $table add $ip_adress",$output);
			$DB->query("UPDATE internet set ?a WHERE user_id=?d",$obj,$client_id);
		}
		success();
		
	}
	
}
?>