<?php
class vlans {
	
	public function __construct(){
		global $err;
		
		$act=preg_replace('/[^a-z_]/','',$_GET['act']);
		if($act){
			call_user_func(array(&$this,$act));
		} 
	}
	
	
	public function get(){
		global $DB;
		$limit=intval($_POST['limit']);
		$start=intval($_POST['start']);
		
		$dir=preg_replace("/[^(ASC|DESC)]/",'',$_POST['dir']);
		if($dir!='ASC'&&$dir!='DESC') $dir='ASC';
		$sort=$_POST['sort'];
		if(!$sort){
			$sort='id';
		}
		
		$data_t = $DB->selectPage($totalCount,"
								SELECT * FROM vlans ORDER BY $sort $dir  
								LIMIT ?d,?d",$start,$limit);
							
		foreach($data_t as $data_k=>$data_v)
		{
			$data[$data_k]["id"] = $data_v["id"];
			$data[$data_k]["name"] = $data_v["name"];
			$data[$data_k]["start_ip"] = long2ip($data_v["start_ip"]);
			$data[$data_k]["end_ip"] = long2ip($data_v["end_ip"]);
		}
		$json=array("totalCount"=>$totalCount,"data"=>$data);
		echo json_encode($json);
	}
	
	public function save(){
		global $DB;
		
		$vlan_id=intval($_GET[vlan_id]);

		if($_POST['start_ip']!="xxx.xxx.xxx.xxx")$obj["start_ip"]=ip2long($_POST['start_ip']);
		if($_POST['end_ip']!="xxx.xxx.xxx.xxx")$obj["end_ip"]=ip2long($_POST['end_ip']);

		if($vlan_id==0){
			if($_POST["name"]!="Название")$obj["name"]=$_POST["name"];
			if(!$obj["name"] || $_POST["name"]=="Название") error("Введите название в формате [a-zA-Z0-9_]!");
			
			$DB->query("INSERT INTO vlans set ?a",$obj);
		} else {
			$DB->query("UPDATE vlans set ?a WHERE id=?d",$obj,$vlan_id);
		}
		
		success();
	}
}
?>