<?php

class clients {
	
	public function __construct(){
		global $err;
		
		$act=preg_replace('/[^a-z_]/','',$_GET['act']);
		if($act){
			call_user_func(array(&$this,$act));
		} 
	}
	
	
	public function get(){
		global $DB;
		$limit=intval($_POST['limit']);
		$start=intval($_POST['start']);
		
		$dir=preg_replace("/[^(ASC|DESC)]/",'',$_POST['dir']);
		if($dir!='ASC'&&$dir!='DESC') $dir='ASC';

		$sort=$_POST['sort'];
		if(!$sort){
			$sort='id';
		}
		
		
		$where_str=array();
		
		function parse_sql_query($item){
			return $item;
		}

		$search=$_POST;
		if (strlen($search["username"]) && $search["username"] != "Логин"){
			$query = split(" ", $search["username"]);
			foreach ($query as $item)
			$where_str[] = " cli.username LIKE '%".parse_sql_query($item)."%'";
		}		
		if (strlen($search["home_phone"]) && $search["home_phone"] != "Домашний телефон"){
			$query = split(" ", $search["home_phone"]);
			foreach ($query as $item)
			$where_str[] = " cli.home_phone LIKE '%".parse_sql_query($item)."%'";
		}
		if (strlen($search["mobile_phone"]) && $search["mobile_phone"] != "Мобильный телефон"){
			$query = split(" ", $search["mobile_phone"]);
			foreach ($query as $item)
			$where_str[] = " cli.mobile_phone LIKE '%".parse_sql_query($item)."%'";
		}
		if (count($where_str)) {
			$where = join(" AND ", $where_str);			
		} else {
			$where = "1=1";
		}
		
		$data = $DB->selectPage($totalCount,"
								SELECT cli.*,pack.name AS pname FROM clients AS cli
								LEFT JOIN internet AS inter ON (inter.user_id=cli.id)
								LEFT JOIN packets AS pack ON (inter.packet_id=pack.id)
								WHERE $where
								ORDER BY $sort $dir 
								LIMIT ?d,?d",$start,$limit);	
		$json=array("totalCount"=>$totalCount,"data"=>$data);
		echo json_encode($json);
	}
	
	public function save(){
		global $DB;
		
		$client_id=intval($_GET[client_id]);
		if($_POST['email']!='E-mail')$obj["email"]=$_POST['email'];
		if($_POST['mobile_phone']!='+7 928XXXXXXX') $obj["mobile_phone"]=$_POST['mobile_phone'];
		if($_POST['home_phone']!='+7 495 XXXXXXX') $obj["home_phone"]=$_POST['home_phone'];
		if($_POST['full_name']!="ФИО") $obj["full_name"]=$_POST['full_name'];
		if($_POST['adress']!="Адрес") $obj["adress"]=$_POST['adress'];
		
		if($client_id==0){
			if(!$obj["full_name"]||$obj["full_name"]=="ФИО") error("Введите ФИО пользователя!");
			$obj["username"]=preg_replace("/[^a-zA-Z0-9_]/",'',$_POST['username']);
			if(!$obj["username"]||$obj["username"]!=$_POST["username"]) error("Введите Логин в формате [a-zA-Z0-9_]!");
			$have= $DB->selectCell("SELECT id FROM clients WHERE username=?",$obj["username"]);
			if($have!=0) error("Пользователь с таким логином уже существует!");
			
			$DB->query("INSERT INTO clients set ?a",$obj);
		} else {
			$DB->query("UPDATE clients set ?a WHERE id=?d",$obj,$client_id);
		}
		
		success();
	}

	public function details(){
		global $DB;
		$data = $DB->select("SELECT cl.* FROM clients AS cl WHERE cl.id=?d",intval($_POST["id"]));	
		
		$json=array("success"=>true,"data"=>$data);
		echo json_encode($json);
	}
	
	public function pay(){
		global $DB;
				
		$client_id=intval($_GET[client_id]);
		$obj["balance"]=intval($_POST['balance']);
		$balance_old= $DB->selectCell("SELECT balance FROM clients WHERE id=$client_id");
		if($client_id==0) error("Клиент не выбран"); 
		if(!$obj["balance"]) error("Введите сумму только цифрами!");
		if($obj["balance"] < 1 || $obj["balance"] > 5000) error("Неверная Сумма! Введите сумму от 1 до 5000");
		$obj["balance"]=$obj["balance"]+$balance_old; 
			
		$DB->query("UPDATE clients set ?a WHERE id=?d",$obj,$client_id);
		
		success();
		
	}

}
?>