function ClientProfile(client_id,create,store){
	
	var some = Math.random();
	var ClientProfile = new Ext.FormPanel({
		frame: true,
		region: 'center',
        bodyStyle: 'padding:4px 4px 0',
        items: [{
			xtype: 'fieldset',
            collapsible: false,
            autoHeight: true,
            collapsed: false,
            bodyStyle: 'margin:4px;',
            items: [
			    {xtype: 'hidden', disabled: true, name: 'id', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'ID'},
			    {xtype:'label', text: 'Логин:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: !create, name: 'username', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'Логин'},
			    {xtype:'label', text: 'Ф.И.О:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: false, name: 'full_name', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'ФИО'},
			    {xtype:'label', text: 'Адрес:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: false, name: 'adress', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'Адрес'},
			    {xtype:'label', text: 'E-mail:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: false, name: 'email', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'E-mail'},
			    {xtype:'label', text: 'Номер мобильного телефона:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: false, name: 'mobile_phone', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'+7 928XXXXXXX'},
			    {xtype:'label', text: 'Номер домашнего телефона:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: false, name: 'home_phone', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'+7 495 XXXXXXX'}
			]
			
        }],
        buttons:[{
			text: 'Сохранить',
			handler: function(){
                ClientProfile.getForm().submit({
                    url: 'wrapper.php?mod=clients&act=save&client_id='+client_id,
                    waitMsg: 'Выполнение запроса...',
                    success: function(p, o){
						if (o.result.success) {
							window.close();
							store.reload();
						} else {
							Ext.Msg.alert("Ошибка!",o.result.errors);
						}
                    },
					failure: function(form, o) {
						Ext.Msg.alert("Ошибка!",o.result.errors);
					}
                });
		      }
        	},{
        	text:'Закрыть',
        	handler: function(){
        		window.close();
        	}
        }
      ]
    });
    	
	var window = new Ext.Window({
		title: 'Профиль Клиента',
		width: 400,
		height: 390,
		minWidth: 300,
		minHeight: 200,
		layout: 'fit',
		plain: true,
		bodyStyle: 'padding:4px;',
		buttonAlign: 'center',
		items: ClientProfile
	});
	
	var conn = new Ext.data.Connection();
	conn.request({
		url: "wrapper.php?mod=clients&act=get",
		method: 'POST',
		params: {
			"client_id": client_id
		},
		success: function(req){
			var data = Ext.decode(req.responseText);
			window.show();
		},
		failure: function(){
			Ext.Msg.alert('Status', 'Ошибка');
		}
	});		
	
	
}


function ClientBalance(client_id,client_name,store){
	var some = Math.random();
	var ClientBalance = new Ext.FormPanel({
		frame: true,
		region: 'center',
        bodyStyle: 'padding:4px 4px 0',
        items: [{
			xtype: 'fieldset',
            collapsible: false,
            autoHeight: true,
            collapsed: false,
            bodyStyle: 'margin:4px;',
            items: [
			    {xtype: 'hidden', disabled: true, name: 'id', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'ID'},
			    {xtype: 'label', text: 'Логин:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: true, name: 'client_name', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText: client_name},
			    {xtype:'label', text: 'Сумма:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: false, name: 'balance', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'Введите сумму'}
			]
        }],
        buttons:[{
			text: 'Пополнить',
			handler: function(){
                ClientBalance.getForm().submit({
                    url: 'wrapper.php?mod=clients&act=pay&client_id='+client_id,
                    waitMsg: 'Выполнение запроса...',
                    success: function(p, o){
						if (o.result.success) {
							window.close();
							store.reload();
							ClientConnect(client_id,client_name);
							
						} else {
							Ext.Msg.alert("Ошибка!",o.result.errors);
						}
                    },
					failure: function(form, o) {
						Ext.Msg.alert("Ошибка!",o.result.errors);
					}
                });
		      }
        	},{
        	text:'Закрыть',
        	handler: function(){
        		window.close();
        	}
        }
      ]
    });
    	
	var window = new Ext.Window({
		title: 'Пополнение баланса клиента',
		width: 400,
		height: 210,
		minWidth: 300,
		minHeight: 100,
		layout: 'fit',
		plain: true,
		bodyStyle: 'padding:4px;',
		buttonAlign: 'center',
		items: ClientBalance
	});
	
	var conn = new Ext.data.Connection();
	conn.request({
		url: "wrapper.php?mod=clients&act=get",
		method: 'POST',
		params: {
			"client_id": client_id,
			"client_name" : client_name
		},
		success: function(req){
			var data = Ext.decode(req.responseText);
			window.show();
			

			
		},
		failure: function(){
			Ext.Msg.alert('Status', 'Ошибка');
		}
	});		
	
	
}

function ClientConnect(id,client_name){
	var some = Math.random();
	var ClientConnect = new Ext.FormPanel({
		frame: true,
		region: 'center',
        bodyStyle: 'padding:4px 4px 0',
        items: [{
			xtype: 'fieldset',
            collapsible: false,
            autoHeight: true,
            collapsed: false,
            bodyStyle: 'margin:4px;',
            items: [
			    {xtype: 'hidden', disabled: true, name: 'id', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText:'ID'},
			    {xtype: 'label', text: 'Логин:', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%'},
			    {xtype: 'textfield', disabled: true, name: 'client_name', cls:'x-form-check-group-label', hideLabel: true, anchor:'100%',emptyText: client_name}

				]
        }],
        buttons:[{
			text: 'Включить услугу',
			handler: function(){
				ClientConnect.getForm().submit({
                    url: 'wrapper.php?mod=inet&act=connect&client_id='+id,
                    waitMsg: 'Выполнение запроса...',
                    success: function(p, o){
						if (o.result.success) {
							window.close();
						} else {
							Ext.Msg.alert("Ошибка!",o.result.errors);
						}
                    },
					failure: function(form, o) {
						Ext.Msg.alert("Ошибка!",o.result.errors);
					}
                });
		      }
        	},{
        	text:'Закрыть',
        	handler: function(){
        		window.close();
        	}
        }
      ]
    });
    	
	var window = new Ext.Window({
		title: 'Включение услуги',
		width: 400,
		height: 180,
		minWidth: 300,
		minHeight: 100,
		layout: 'fit',
		plain: true,
		bodyStyle: 'padding:4px;',
		buttonAlign: 'center',
		items: ClientConnect
	});
	
	var conn = new Ext.data.Connection();
	conn.request({
		url: "wrapper.php?mod=clients&act=get",
		method: 'POST',
		params: {
			"id": id,
			"client_name": client_name
		},
		success: function(req){
			var data = Ext.decode(req.responseText);
			window.show();
			

			
		},
		failure: function(){
			Ext.Msg.alert('Status', 'Ошибка');
		}
	});		
	

}

function getClients(){

		var fields = [
						{name: 'id'},
						{name: 'username'},
						{name: 'full_name'},
						{name: 'balance'},
						{name: 'pname'},
						{name: 'adress'},
						{name: 'mobile_phone'},
						{name: 'home_phone'}
					];
					
		var mapping = [
						{name: 'id', mapping: 'id'},
						{name: 'username', mapping: 'username'},
						{name: 'full_name', mapping: 'full_name'},
						{name: 'balance', mapping: 'balance'},
						{name: 'pname', mapping: 'pname'},
						{name: 'adress', mapping: 'adress'},
						{name: 'mobile_phone', mapping: 'mobile_phone'},
						{name: 'home_phone', mapping: 'home_phone'}
					];	
					
					
		var columns = 	[
							{
								header: '#',
								dataIndex: 'id',
								hidden: true,
								sortable: true
							},{
								header: 'Пользователь',
								dataIndex: 'username',
								sortable: true
							},{
								header: 'Полное имя',
								dataIndex: 'full_name',
								sortable: true
							},{
								header: 'Баланс',
								dataIndex: 'balance',
								sortable: true
							},{
								header: 'Пакет',
								dataIndex: 'pname',
								sortable: true
							},{
								header: 'Адрес',
								dataIndex: 'adress',
								sortable: true
							},{
								header: 'Номер моб. тел.',
								dataIndex: 'mobile_phone',
								sortable: true
							},{
								header: 'Номер дом. тел.',
								dataIndex: 'home_phone',
								sortable: true
							}
						];					
	
	var store = new Ext.data.GroupingStore({
			remoteSort: true,
			sortInfo:{field: 'id', direction: "DESC"},
			proxy: new Ext.data.HttpProxy({
				url: "wrapper.php?mod=clients&act=get"
			}),
			reader: new Ext.data.JsonReader({
				root: 'data',
				id: 'id',
				totalProperty: 'totalCount',
				fields: fields
			},
				mapping
			)
		});
	
	var grid = new Ext.grid.GridPanel({
		id: 'grid-clients-',
		region: 'center',
		closable: true,
		store: store,
		groupField:'id',
		columns:columns,
		view: new Ext.grid.GroupingView({
			forceFit:true,
			groupTextTpl: '{text} ({[values.rs.length]} {[values.rs.length > 1 ? "Items" : "Item"]})'
	    }),
		sm: new Ext.grid.RowSelectionModel({singleSelect: true}),
		iconCls: "icon-group",
		title: 'Список клиентов',
		loadMask: {
			msg: "Загрузка данных..."
		},
		tbar: [{
				text: 'Создать',
				tooltip: 'Создать нового клиента',
				iconCls: "icon-new-user",
				handler: function(){
					ClientProfile(0,true,store);
				}
			},{
				text: 'Изменить',
				tooltip: 'Изменение клиента',
				iconCls: "icon-edit-user",
				handler: function(){
					var row=grid.getSelectionModel().getSelected();
					if(row){
						ClientProfile(row.data.id,false);
					}
				}
			},{
				text: 'Пополнить',
				tooltip: 'Пополнение баланса клиента',
				iconCls: "icon-coins-add",
				handler: function(){
					var row=grid.getSelectionModel().getSelected();
					if(row){
						ClientBalance(row.data.id,row.data.username,store);
					}
				}
			},{
				text: 'Добавить услугу Интернета',
				iconCls: "icon-world-link",
				handler: function(){
					var row=grid.getSelectionModel().getSelected();
					if(row){
						ServiceProfile(row.data.id,row.data.username);
					}
				}
			}],

		bbar: new Ext.PagingToolbar({
			pageSize: 50,
			store: store,
			displayInfo: true,
			displayMsg: 'Отображаемые записи {0} - {1} of {2}',
			emptyMsg: "Нет записей"
		}),
		onContextClick: function(grid, index, e){
				var row=grid.getSelectionModel().getSelected();
				
				this.menu = new Ext.menu.Menu({
					id: 'grid-ctx',
					items: [{
								text: 'Добавить услугу Интернета',
								iconCls: "icon-world-link",
								handler: function(){
									var row=grid.getSelectionModel().getSelected();
									if(row){
										ServiceProfile(row.data.id,row.data.username);
									}
								}
							},{
								text: 'Пополнить',
								tooltip: 'Пополнение баланса клиента',
								iconCls: "icon-coins-add",
								handler: function(){
									var row=grid.getSelectionModel().getSelected();
									if(row){
										ClientBalance(row.data.id,row.data.username,store);
									}
								}
							}]
				});
				
				e.stopEvent();
				this.menu.showAt(e.getXY());
			},
		view: new Ext.grid.GroupingView({
            forceFit:true,
            showGroupName: false,
            enableNoGroups:false, // REQUIRED!
            hideGroupedColumn: true
        })
	});

		grid.on('rowcontextmenu', grid.onContextClick, grid);
		grid.on('rowdblclick', function(grid, row, e) {
				var id=grid.getView().ds.getAt(row).data.id;
				var conn = new Ext.data.Connection();
				conn.request({
					url: "wrapper.php?mod=clients&act=details",
					method: 'POST',
					params: {
						"id": id
					},
					success: function(req){
						var data = Ext.decode(req.responseText);
						tplDetails.overwrite(panelDetails.body, data);
					},
					failure: function(){
						Ext.Msg.alert('Status', 'Ошибка');
					}
				});		
				
				var tplDetails = new Ext.XTemplate(
				    '<p><tpl for="data">',
					'<p><b>ID:</b> {id}</p>',
				    '<p><b>Логин:</b> {username}</p>',
				    '<p><b>Полное Имя:</b> {full_name}</p>',
				    '<p><b>Адрес:</b> {adress}</p>',
				    '<p><b>Баланс:</b> {balance}</p>',
				    '<p><b>E-mail:</b> {email}</p>',
				    '<p><b>Мобильный телефон:</b> {mobile_phone}</p>',
				    '<p><b>Домашний телефон:</b> {home_phone}</p>',
				    '</tpl></p>'
		
				);
		
				var panelDetails= new Ext.Panel({ 
					title:'Детали',
					frame: true,
					collapsible:true,
					autoScroll:true
				});						
				
				var m_client_details = new Ext.Panel({  
					title: 'Детали клиента',
					layout:'border',
					closable: true,
					items:[{  
						title: 'Детали клиента',
						frame: true,
						region:'center',
						autoScroll:true,
						items:[panelDetails]
					}]
				}); 			
				
				var tp = Ext.getCmp('main-tabs');
				tp.add(m_client_details).show();
				tp.doLayout();
				
			});
		
		function submitSearch() {
	        var params=store.lastOptions.params;
	        params['no_validation']='';
	        params['start']=0;
	        var fFields=searchForm.getForm().getValues();
	        for(var f in fFields){     
	        	params[f]=fFields[f];
	        }
			store.reload({params: params});			
		}	    
    
		var panelCol1 = new Ext.Panel({  
			layout:'form',
			width: 180,
			minWidth: 180,  
			items: [{
					xtype:'textfield',
					hideLabel: true,	
					name: 'username',
					anchor:'100%',
					emptyText:'Логин',
					fireKey: function(e){if (e.getKey() == e.ENTER) { submitSearch(); } }
				},{
					xtype:'textfield',
					hideLabel: true,	
					name: 'home_phone',
					anchor:'100%',
					emptyText:'Домашний телефон',
					fireKey: function(e){if (e.getKey() == e.ENTER) { submitSearch(); } }
				},{
					xtype:'textfield',
					hideLabel: true,	
					name: 'mobile_phone',
					anchor:'100%',
					emptyText:'Мобильный телефон',
					fireKey: function(e){if (e.getKey() == e.ENTER) { submitSearch(); } }
				}
			]
		}); 
		
	    var searchForm = new Ext.FormPanel({
			titlebar: false, 
	        title: 'Поиск',
	        collapsible:true,
	        collapsed:true,
	        autoHeight: true,
	        split:true,
			width: 180,
			minWidth: 180,
			defaults:{autoHeight:true}, 
	    	frame:true,
	        region: 'east',
	        layout:'column',
			items:[panelCol1],
	        buttons:[{
	        	text: 'Искать',
	        	handler: function(){
					submitSearch();
	        	}
	        },{
	        	text: 'Сбросить',
	        	handler: function(){
	        		searchForm.getForm().reset();
	        		store.reload({params: {start: 0, limit: 50}});
	        	}
	        }]
	    });
	
	    var panel= {
	    	id: 'panel-clients-',
			title: 'Клиенты',
			iconCls: 'icon-group',
			closable: true,
			layout:'border',
			items:[searchForm,grid]
		};
	
	var tp = Ext.getCmp('main-tabs');
	tp.add(panel).show();
	tp.doLayout();
	
	store.load({
		params: {
			start: 0,
			limit: 50
		}
	});
}